SystemOrganization addCategory: #'Pier-Paypal-Model'!
SystemOrganization addCategory: #'Pier-Paypal-Magritte'!
SystemOrganization addCategory: #'Pier-Paypal-Seaside'!

MAActionColumn subclass: #PRPaypalCommandColumn
	instanceVariableNames: 'item store button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Magritte'!

!PRPaypalCommandColumn commentStamp: 'jmck 3/17/2009 09:39' prior: 0!
For the items report, which is an MAReport!

PRPaypalCommandColumn subclass: #PRPaypalAddToCartCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Magritte'!

!PRPaypalAddToCartCommandColumn commentStamp: 'jmck 3/17/2009 09:39' prior: 0!
Puts an Add to Cart button on the item report!

!PRPaypalAddToCartCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/17/2009 11:19'!
altText
	^ 'Add to Cart'! !

!PRPaypalAddToCartCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/17/2009 11:17'!
cmdValue
	^'_cart'! !

!PRPaypalAddToCartCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/15/2009 19:59'!
imageUrl
	^'https://www.paypal.com/en_US/i/btn/btn_cart_SM.gif'! !

PRPaypalCommandColumn subclass: #PRPaypalBuyNowCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Magritte'!

!PRPaypalBuyNowCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/17/2009 11:19'!
altText
	^ 'Buy Now'! !

!PRPaypalBuyNowCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/17/2009 11:18'!
cmdValue
	^'_xclick'! !

!PRPaypalBuyNowCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/19/2009 21:48'!
imageUrl
	^'https://www.paypal.com/en_US/i/btn/btn_buynow_SM.gif'! !

!PRPaypalCommandColumn class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 22:04'!
inStore: aStore
	^self new 
		store: aStore; 
		yourself! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 18:25'!
altText
	^self subclassResponsibility! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 4/12/2009 14:33'!
button
	"Answer the value of button"

	| btn |

	^ button ifNil: [ 
		self store buyNow 
			ifTrue: [ btn := PRPaypalBuyNowButton new ]
			ifFalse: [ btn := PRPaypalAddToCartButton new ].
		button := btn
			item: self item; 
			store: self store; 
			yourself 
		]! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:38'!
button: anObject
	"Set the value of button"

	button := anObject! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/15/2009 22:14'!
cmdValue
	self subclassResponsibility! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 09:07'!
defaultUseLinks
	^false! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 18:25'!
imageUrl
	^self subclassResponsibility! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 19:17'!
item
	"Answer the value of item"

	^ item! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 19:34'!
item: anObject
	"Set the value of item"

	item := anObject! !

!PRPaypalCommandColumn methodsFor: 'rendering' stamp: 'jmck 4/12/2009 14:32'!
renderCellFormContent: anItem on: html
	"html form
		attributeAt: #target put: 'PayPal';
		action: 'https://www.paypal.com/cgi-bin/webscr';
		post;
		with: [
			self renderCmdInputOn: html.
			self renderStoreInputsOn: html.
			self renderItemInputsFor: anItem on: html.
			self renderPaypalButtonOn: html. ]"
		
	html render: self button
		
	! !

!PRPaypalCommandColumn methodsFor: 'rendering' stamp: 'jmck 3/16/2009 18:10'!
renderCmdInputOn: html
	html hiddenInput
		name: 'cmd';
		value: self cmdValue.
	html hiddenInput
		name: 'quantity';
		value: '1'.
	html hiddenInput
		name: 'add';
		value: '1'.
		
! !

!PRPaypalCommandColumn methodsFor: 'rendering' stamp: 'jmck 3/31/2009 21:04'!
renderHiddenInputFor: aDescription of: anObject on: html
	| value |
	value := anObject readUsing: aDescription.
	value isNil ifFalse: [
		aDescription isPaypalImage ifTrue: [ value := value urlOn: html ].
		aDescription isPaypalColor ifTrue: [ value := value asHTMLColor	].
		html hiddenInput
			name: aDescription accessor accessor key;
			value: value ]
			
! !

!PRPaypalCommandColumn methodsFor: 'rendering' stamp: 'jmck 3/29/2009 03:13'!
renderItemInputsFor: anItem on: html
	anItem description do: [ :desc | 
		desc isPaypal ifTrue: [ 
			self renderHiddenInputFor: desc of: anItem on: html] ].! !

!PRPaypalCommandColumn methodsFor: 'rendering' stamp: 'jmck 3/15/2009 20:16'!
renderPaypalButtonOn: html
	html imageButton 
		name: 'submit';
		url: self imageUrl;
		attributeAt: 'alt' put: self altText! !

!PRPaypalCommandColumn methodsFor: 'rendering' stamp: 'jmck 3/29/2009 03:11'!
renderStoreInputsOn: html
	self store description do: [ :desc |
		desc isPaypal ifTrue: [ 
			self renderHiddenInputFor: desc of: self store on: html] ].! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 19:17'!
store
	"Answer the value of store"

	^ store! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 19:18'!
store: anObject
	"Set the value of store"

	store := anObject! !

PRDefaultView subclass: #PRPaypalStoreItemView
	instanceVariableNames: 'item store button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

!PRPaypalStoreItemView class methodsFor: 'as yet unclassified' stamp: 'jmck 3/28/2009 18:28'!
forItem: anItem
	^self new item: anItem! !

!PRPaypalStoreItemView methodsFor: 'accessing' stamp: 'jmck 4/9/2009 21:22'!
button
	"Answer the value of button"
	| btn |

	^ button ifNil: [ 
		self store buyNow 
			ifTrue: [ btn := PRPaypalBuyNowButton new ]
			ifFalse: [ btn := PRPaypalAddToCartButton new ].
		button := btn
			item: self item; 
			store: self store; 
			yourself 
		]! !

!PRPaypalStoreItemView methodsFor: 'accessing' stamp: 'jmck 4/9/2009 19:37'!
button: anObject
	"Set the value of button"

	button := anObject! !

!PRPaypalStoreItemView methodsFor: 'accessing' stamp: 'jmck 4/9/2009 19:39'!
defaultButtonClass
	^PRPaypalAddToCartButton! !

!PRPaypalStoreItemView methodsFor: 'accessing' stamp: 'jmck 3/16/2009 22:33'!
item
	^ item ifNil: [ item := self find: PRPaypalStoreItem ]! !

!PRPaypalStoreItemView methodsFor: 'accessing' stamp: 'jmck 3/28/2009 18:29'!
item: anItem
	item := anItem! !

!PRPaypalStoreItemView methodsFor: 'accessing' stamp: 'jmck 4/9/2009 21:18'!
renderContentOn: html
	| value |
	super renderContentOn: html.
	html div class: 'store-item'; with: [
	html table: [
		self item description do: [ :desc | 
			desc isPaypal ifTrue: [
				html tableRow: [
					html tableHeading: desc label.
					value := self item readUsing: desc.
					value isNil ifFalse: [
						desc isCurrency 
							ifTrue: [ value := (value asMoney: '$') asString ].
						html tableData: value ] ] ] ].
		html tableRow: [ html tableHeading: 'Image'. html tableData: [ html image class: 'item'; with: item image ] ].
		html tableRow: [ html tableData class: 'paypalbutton'; colSpan: 2; with: [ html render: self button ] ]. 
			
		]
	]! !

!PRPaypalStoreItemView methodsFor: 'accessing' stamp: 'jmck 4/9/2009 19:40'!
store
	"Answer the value of store"

	^ store ifNil: [ store := self find: PRPaypalStore ]! !

!PRPaypalStoreItemView methodsFor: 'accessing' stamp: 'jmck 4/9/2009 19:37'!
store: anObject
	"Set the value of store"

	store := anObject! !

PRDefaultView subclass: #PRPaypalStoreView
	instanceVariableNames: 'items report store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

!PRPaypalStoreView methodsFor: 'accessing' stamp: 'jmck 3/31/2009 21:40'!
buildReport
	| rpt col |
	rpt := MAReport new rows: self reportItems. 
	rpt addColumn: (PRStructureCommandColumn on: self).
	PRPaypalStoreItem description do: [ :desc |
		desc isPaypal ifTrue: [
			col := rpt addColumnDescription: desc.
			desc isCurrency ifTrue: [ col format: [ :item :html | self renderCurrency: item on: html ] ] ] ].
	rpt addColumnSelector: #image.
	( self store addToCart ) 
		ifTrue: [ rpt addColumn: (PRPaypalAddToCartCommandColumn new store: self context structure; yourself) ].
	( self store buyNow ) 
		ifTrue: [ rpt addColumn: (PRPaypalBuyNowCommandColumn new store: self context structure; yourself) ].
	^rpt! !

!PRPaypalStoreView methodsFor: 'rendering' stamp: 'jmck 3/29/2009 03:47'!
children
	"(self store listingStyle = #report) 
		ifTrue: [" ^Array with: self report "]
		ifFalse: [ self store listingStyle = #table ifTrue: [ ^Array with: items ] ]"! !

!PRPaypalStoreView methodsFor: 'accessing' stamp: 'jmck 3/28/2009 18:31'!
items
	^ items
		ifNil: [ 
			items := OrderedCollection new.
			self reportItems do: [ :each |
				items add: (PRPaypalStoreItemView newFor: each) ] ]! !

!PRPaypalStoreView methodsFor: 'rendering' stamp: 'jmck 4/2/2009 21:49'!
renderContentOn: html
	super renderContentOn: html.
	html render: self report.
	
	"(self store listingStyle = #report) 
		ifTrue: [ html render: self report ]
		ifFalse: [ self store listingStyle = #table ifTrue: [ self renderStoreOn: html ] ]"
! !

!PRPaypalStoreView methodsFor: 'rendering' stamp: 'jmck 3/31/2009 21:48'!
renderCurrency: item on: html
	| str |
	str := String streamContents: [ :strm | 
			(Money amount: (item propertyAt: #amount) currency: '$') printOn: strm ].
	html text: str.
		! !

!PRPaypalStoreView methodsFor: 'rendering' stamp: 'jmck 3/28/2009 11:21'!
renderStoreItem: anItem on: html
	html tableData: [ html render: anItem ]

"	html tableData: [
			html anchor
				goto: (self context structure: anItem);
				with: (self labelFor: anItem)	].
				
	anItem description do: [ :desc |
		desc isPaypal ifTrue: [
			html tableData: [ html text: ((anItem readUsing: desc) asString) ] ] ].
"
"add PayPal buttons
	self store addToCart
		ifTrue: [ self renderBuyItNowButtonOn: html ]
	self store butNow
		ifTrue: [self renderAddToCartButtonOn: html ]
"! !

!PRPaypalStoreView methodsFor: 'rendering' stamp: 'jmck 3/16/2009 19:50'!
renderStoreItemHeaderOn: html
	html tableColumnGroup: [
	html tableRow: [ 
		PRPaypalStoreItem description do: [ :desc |
			desc isPaypal ifTrue: [
				html tableData: [ desc label ] ] ] ] ].
		
	self renderStoreItemsOn: html.
! !

!PRPaypalStoreView methodsFor: 'rendering' stamp: 'jmck 3/15/2009 16:42'!
renderStoreItemsOn: html
	(self context structure allStoreItemsIn: self context) do: [ :each | 
		html tableRow: [ 
			self renderStoreItem: each on: html ]
	]! !

!PRPaypalStoreView methodsFor: 'rendering' stamp: 'jmck 3/28/2009 18:35'!
renderStoreOn: html
	html table
		class: 'paypal-store';
		with: [
			html tableRow: [ 
				self items do: [ :each | self renderStoreItem: each on: html ] ] ]
		
	! !

!PRPaypalStoreView methodsFor: 'accessing' stamp: 'jmck 3/14/2009 20:13'!
report
	^ report ifNil: [ report := self buildReport ]! !

!PRPaypalStoreView methodsFor: 'convenience' stamp: 'jmck 3/15/2009 17:31'!
reportItems
	^ self context structure allStoreItemsIn: self context! !

!PRPaypalStoreView methodsFor: 'accessing' stamp: 'jmck 3/29/2009 15:53'!
store
	^store ifNil: [ store := self context structure ]! !

WAComponent subclass: #PRPaypalButton
	instanceVariableNames: 'item store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

PRPaypalButton subclass: #PRPaypalAddToCartButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

!PRPaypalAddToCartButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:50'!
altText
	^ 'Add to Cart'! !

!PRPaypalAddToCartButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:50'!
cmdValue
	^'_cart'! !

!PRPaypalAddToCartButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:50'!
imageUrl
	^'https://www.paypal.com/en_US/i/btn/btn_cart_SM.gif'! !

!PRPaypalButton class methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:48'!
forStore: aStore
	^self new 
		store: aStore; 
		yourself! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:49'!
altText
	^self subclassResponsibility! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:42'!
cmdValue
	self subclassResponsibility! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:47'!
imageUrl
	^self subclassResponsibility! !

!PRPaypalButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:48'!
item
	"Answer the value of item"

	^ item! !

!PRPaypalButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:48'!
item: anObject
	"Set the value of item"

	item := anObject! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:42'!
renderCmdInputOn: html
	html hiddenInput
		name: 'cmd';
		value: self cmdValue.
	html hiddenInput
		name: 'quantity';
		value: '1'.
	html hiddenInput
		name: 'add';
		value: '1'.
		
! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 19:42'!
renderContentOn: html
	html form
		attributeAt: #target put: 'PayPal';
		action: 'https://www.paypal.com/cgi-bin/webscr';
		post;
		with: [
			self renderCmdInputOn: html.
			self renderStoreInputsOn: html.
			self renderItemInputsOn: html.
			self renderPaypalButtonOn: html. ]
		
! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:44'!
renderHiddenInputFor: aDescription of: anObject on: html
	| value |
	value := anObject readUsing: aDescription.
	value isNil ifFalse: [
		aDescription isPaypalImage ifTrue: [ value := value urlOn: html ].
		aDescription isPaypalColor ifTrue: [ value := value asHTMLColor	].
		html hiddenInput
			name: aDescription accessor accessor key;
			value: value ]
			
! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:53'!
renderItemInputsOn: html
	item description do: [ :desc | 
		desc isPaypal ifTrue: [ 
			self renderHiddenInputFor: desc of: item on: html] ].! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:45'!
renderPaypalButtonOn: html
	html imageButton 
		name: 'submit';
		url: self imageUrl;
		attributeAt: 'alt' put: self altText! !

!PRPaypalButton methodsFor: 'as yet unclassified' stamp: 'jmck 4/9/2009 18:43'!
renderStoreInputsOn: html
	self store description do: [ :desc |
		desc isPaypal ifTrue: [ 
			self renderHiddenInputFor: desc of: self store on: html] ].! !

!PRPaypalButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:48'!
store
	"Answer the value of store"

	^ store! !

!PRPaypalButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:48'!
store: anObject
	"Set the value of store"

	store := anObject! !

PRPaypalButton subclass: #PRPaypalBuyNowButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

!PRPaypalBuyNowButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:49'!
altText
	^ 'Buy Now'! !

!PRPaypalBuyNowButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:49'!
cmdValue
	^'_xclick'! !

!PRPaypalBuyNowButton methodsFor: 'accessing' stamp: 'jmck 4/9/2009 18:49'!
imageUrl
	^'https://www.paypal.com/en_US/i/btn/btn_buynow_SM.gif'! !

!Money methodsFor: '*pier-paypal' stamp: 'jmck 4/2/2009 22:21'!
asString
	"| thousands rem | 
	thousands := amount // 1000.
	rem := amount \\ 1000."
	
	^String streamContents: [ :strm | self printOn: strm ]! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/31/2009 21:15'!
beCurrency
	self propertyAt: #currency put: true.
! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/15/2009 20:42'!
bePaypal
	self propertyAt: #paypal put: true.
	self group: 'Paypal Settings'! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/29/2009 03:34'!
bePaypalColor
	self propertyAt: #paypalColor put: true.
! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/29/2009 03:32'!
bePaypalImage
	self propertyAt: #paypalImage put: true.
! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/31/2009 21:11'!
bePaypalItem
	self propertyAt: #paypalItem put: true.
! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/31/2009 21:15'!
isCurrency
	^self propertyAt: #currency ifAbsent: [ false ]! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/15/2009 20:38'!
isPaypal
	^self propertyAt: #paypal ifAbsent: [ false ]! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/29/2009 16:12'!
isPaypalColor
	^self propertyAt: #paypalColor ifAbsent: [ false ]! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/29/2009 16:12'!
isPaypalImage
	^self propertyAt: #paypalImage ifAbsent: [ false ]! !

!MADescription methodsFor: '*pier-paypal' stamp: 'jmck 3/31/2009 21:11'!
isPaypalItem
	^self propertyAt: #paypalItem ifAbsent: [ false ]! !

MACommandColumn subclass: #PRStructureCommandColumn
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Magritte'!

!PRStructureCommandColumn commentStamp: 'jmck 3/17/2009 09:39' prior: 0!
To put a link to the item in the item listing report!

!PRStructureCommandColumn class methodsFor: 'as yet unclassified' stamp: 'jmck 3/16/2009 21:13'!
on: aStructure
	^ self new
		parent: aStructure! !

!PRStructureCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/16/2009 21:14'!
parent
	"Answer the value of parent"

	^ parent! !

!PRStructureCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/16/2009 21:14'!
parent: anObject
	"Set the value of parent"

	parent := anObject! !

!PRStructureCommandColumn methodsFor: 'rendering' stamp: 'jmck 3/16/2009 21:02'!
renderCellFormContent: aStructure on: html
	self renderCellLinkContent: aStructure on: html! !

!PRStructureCommandColumn methodsFor: 'rendering' stamp: 'jmck 3/16/2009 22:25'!
renderCellLinkContent: aStructure on: html
	html anchor
		goto: (parent context structure: aStructure);
		with:  aStructure title! !

PRCase subclass: #PRPaypalStore
	instanceVariableNames: 'listingStyle buyNow addToCart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Model'!

!PRPaypalStore class methodsFor: 'testing' stamp: 'jmck 3/14/2009 23:48'!
canBeParentOf: aClass
	^ aClass includesBehavior: PRPaypalStoreItem! !

!PRPaypalStore class methodsFor: 'defaults' stamp: 'jmck 3/15/2009 00:04'!
defaultBN
	^'pier.seaside.smalltalk'! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:04'!
descriptionAddToCartColumn
	^MABooleanDescription new
		accessor: #addToCart;
		label: 'Use Add to Cart button for items';
		comment: 'Buy Now setting';
		default: false;
		priority: 200;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 20:41'!
descriptionBackgroundColor
	^MAColorDescription new
		propertyAccessor: 'cpp_ headerback_ color';
		label: 'Background Color';
		comment: 'Background color for logo that PayPal will display';
		priority: 144;
		bePaypal;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:02'!
descriptionBn
	^MAStringDescription new
		propertyAccessor: 'bn';
		label: 'Store Builder Name';
		comment: '"Builder Name" for this store';
		default: self defaultBN;
		priority: 111;
		bePaypal;
		beEditable;
		beOptional;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:02'!
descriptionBusiness
	^MAStringDescription new
		propertyAccessor: 'business';
		label: 'Business';
		comment: '"Buisness ID for this store (account email address)';
		priority: 110;
		bePaypal;
		beEditable;
		beRequired;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/19/2009 22:41'!
descriptionBuyNowColumn
	^MABooleanDescription new
		accessor: #buyNow;
		label: 'Add Buy Now button to items';
		comment: 'Buy Now setting';
		default: false;
		priority: 210;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:02'!
descriptionCurrencyCode
	^MASingleOptionDescription new
		options: #('USD' 'EUR' 'YEN' 'LYRA');
		propertyAccessor: 'currency_code';
		label: 'Currency code';
		comment: 'Currency code';
		priority: 112;
		bePaypal;
		beEditable;
		beRequired;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:02'!
descriptionHeaderBorderColor
	^MAColorDescription new
		propertyAccessor: 'cpp_ headerborder_color';
		label: 'Header Border Color';
		comment: 'Header border color for logo that PayPal will display';
		priority: 142;
		bePaypal;
		bePaypalColor;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:02'!
descriptionHeaderImage
	^MAFileDescription new
		propertyAccessor: 'cpp_header_ image';
		label: 'Header Image';
		comment: 'URL for logo image that PayPal will display';
		priority: 141;
		bePaypal;
		bePaypalImage;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:02'!
descriptionListingStyle
	^MASingleOptionDescription new
		options: #(#report #table);
		accessor: #listingStyle;
		label: 'Listing Style';
		comment: 'Report or Table';
		default: #report;
		priority: 220;
		beEditable;
		beRequired;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:03'!
descriptionLogoImage
	^MAFileDescription new
		propertyAccessor: 'image_url';
		label: 'Logo Image';
		comment: 'URL for logo image that PayPal will display';
		priority: 140;
		bePaypal;
		bePaypalImage;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:03'!
descriptionMRB
	^MAStringDescription new
		propertyAccessor: 'mrb';
		label: 'Merchant Referral Bonus ID';
		comment: 'MRB ID issued by PayPal';
		priority: 131;
		bePaypal;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:03'!
descriptionNote
	^MASingleOptionDescription new
		optionsAndLabels: {'0'->'Show note text box'. '1'->'Hide note textbox'.};
		propertyAccessor: 'no_note';
		label: 'Show/Hide Note textbox';
		comment: 'Whether or not to allow buyer to enter a note';
		priority: 121;
		bePaypal;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:03'!
descriptionNotifyUrl
	^MAStringDescription new
		propertyAccessor: 'notify_url';
		label: 'Notify URL';
		comment: 'The URL to which PayPal posts information about the transaction';
		priority: 132;
		bePaypal;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:03'!
descriptionPAL
	^MAStringDescription new
		propertyAccessor: 'pal';
		label: 'Paypal ID';
		comment: 'Pal ID issued by PayPal';
		priority: 130;
		bePaypal;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:03'!
descriptionPayflowColor
	^MAColorDescription new
		propertyAccessor: 'cpp_payflow_ color';
		label: 'Payflow color';
		comment: 'Payflow color for logo that PayPal will display';
		priority: 143;
		bePaypal;
		beEditable;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 4/7/2009 22:03'!
descriptionShipping
	^MASingleOptionDescription new
		optionsAndLabels: {'0'->'Prompt - Required'. '1'->'Do not prompt'. '2'->'Prompt - Required'};
		propertyAccessor: 'no_shipping';
		label: 'Shipping Address Option';
		comment: 'Whether or not to require shipping address Unmatched string quote ->';
		priority: 120;
		bePaypal;
		beEditable;
		beRequired;
		yourself! !

!PRPaypalStore class methodsFor: 'testing' stamp: 'jmck 3/14/2009 11:13'!
isAbstract
	^false! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/19/2009 22:54'!
addToCart
	"Answer the value of addToCart"

	^ addToCart ifNil: [ addToCart := true ]! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/19/2009 22:42'!
addToCart: anObject
	"Set the value of addToCart"

	addToCart := anObject! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/15/2009 01:50'!
allStoreItemsIn: aContext
	"Answer all the comments in choronological order."

	^ ((aContext enumeratorFor: self) all
		select: [ :each |
			each isStoreItem ])
		sort: [ :a :b | (a propertyAt: 'item_number') < (b propertyAt: 'item_number') ];
		yourself! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/19/2009 22:54'!
buyNow
	"Answer the value of buyNow"

	^ buyNow ifNil: [ buyNow := false ]! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/19/2009 22:42'!
buyNow: anObject
	"Set the value of buyNow"

	buyNow := anObject! !

!PRPaypalStore methodsFor: 'testing' stamp: 'jmck 3/15/2009 01:50'!
isStoreItem
	^false! !

!PRPaypalStore methodsFor: 'testing' stamp: 'jmck 3/15/2009 01:47'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/19/2009 22:54'!
listingStyle
	"Answer the value of listingStyle"

	^ listingStyle ifNil: [ listingStyle := #report ]! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/19/2009 22:42'!
listingStyle: anObject
	"Set the value of listingStyle"

	listingStyle := anObject! !

!PRPaypalStore methodsFor: 'rendering' stamp: 'jmck 3/15/2009 01:34'!
viewComponentClass
	^ PRPaypalStoreView! !

PRCase subclass: #PRPaypalStoreItem
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Model'!

!PRPaypalStoreItem class methodsFor: 'testing' stamp: 'jmck 3/14/2009 23:47'!
canBeChildOf: aClass
	^aClass includesBehavior: PRPaypalStore! !

!PRPaypalStoreItem class methodsFor: 'testing' stamp: 'jmck 3/14/2009 23:46'!
canBeParentOf: aClass
	^false! !

!PRPaypalStoreItem class methodsFor: 'accessing-description' stamp: 'jmck 4/7/2009 22:04'!
descriptionAmount
	^MANumberDescription new
		propertyAccessor: #amount;
		label: 'Price';
		comment: 'Selling price for this item';
		priority: 130;
		bePaypal;
		beCurrency;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'accessing-description' stamp: 'jmck 4/7/2009 22:04'!
descriptionImage
	^ MAFileDescription new
		accessor: #image;
		label: '';
		priority: 199;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'accessing-description' stamp: 'jmck 4/7/2009 22:04'!
descriptionItemName
	^MAStringDescription new
		propertyAccessor: 'item_name';
		label: 'Description';
		comment: 'Description of item';
		priority: 120;
		bePaypal;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'accessing-description' stamp: 'jmck 4/7/2009 22:04'!
descriptionItemNumber
	^MAStringDescription new
		propertyAccessor: 'item_number';
		label: 'Item';
		comment: 'Pass-through variable for you to track product or service purchased';
		priority: 110;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'accessing-description' stamp: 'jmck 3/16/2009 23:34'!
descriptionQuantity
	"currently not used"
	^MANumberDescription new
		propertyAccessor: 'quantity';
		label: 'Qty';
		priority: 190;
		default: 1;
		bePositive;
		beHidden;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'accessing-description' stamp: 'jmck 4/7/2009 22:05'!
descriptionWeight
	^MANumberDescription new
		propertyAccessor: 'weight';
		label: 'Weight';
		comment: 'Total weight for this line item';
		priority: 150;
		beEditable;
		bePositive;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'accessing-description' stamp: 'jmck 4/7/2009 22:05'!
descriptionWeightUnit
	^MASingleOptionDescription new
		options: #( 'lbs' 'kgs');
		propertyAccessor: 'weight_unit';
		label: 'Weight Unit';
		comment: 'Units of measure for the weight for this line item';
		priority: 160;
		default: 'lbs';
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'testing' stamp: 'jmck 3/15/2009 02:17'!
isAbstract
	^false! !

!PRPaypalStoreItem methodsFor: 'accessing' stamp: 'jmck 3/16/2009 22:59'!
image
	"Answer the value of image"

	^ image! !

!PRPaypalStoreItem methodsFor: 'accessing' stamp: 'jmck 3/16/2009 22:59'!
image: anObject
	"Set the value of image"

	image := anObject! !

!PRPaypalStoreItem methodsFor: 'testing' stamp: 'jmck 3/15/2009 01:51'!
isStoreItem
	^true! !

!PRPaypalStoreItem methodsFor: 'rendering' stamp: 'jmck 3/15/2009 01:35'!
viewComponentClass
	^ PRPaypalStoreItemView! !
